#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"SimpleImage.h"
#include"ppmio.h"
#include"fastgb.h"


double getVariance(Image *in){
  double ave=0.0;
  double sdvi=0.0;
  int i,j,k;
  
  for(j=0;j<in->sy;j++)
    for(k=0;k<in->sx;k++){
      ave += in->img[j][k];
      sdvi += in->img[j][k]*in->img[j][k];
      
    }
  ave /= ((double)(in->sx*in->sy));
  sdvi /= ((double)(in->sx*in->sy));
  sdvi -= (ave*ave);
  
  return sqrt(sdvi);


}




//Color Edge-Preserving Smoothing 
int main(int argc,char *argv[]){
  
  Image *inR = new Image();
  Image *inG = new Image();
  Image *inB = new Image();
  getPPM(inR,inG,inB,argv[1]);
  

  double sigI = atof(argv[3]);
  
  int dr = 6;
  double error = 1.0;
  int N=5;
  double varR = getVariance(inR);
  double varG = getVariance(inG);
  double varB = getVariance(inB);
  
  
  
  
  double sigIR = sigI*varR;
  double sigIG = sigI*varG;
  double sigIB = sigI*varB;
  
  
  fastgb *myFGT = new fastgb(dr);
  
  
  
    
  myFGT->FastBilateralFilter(inR,inG,inB,sqrt(2.0*sigIR*sigIR),sqrt(2.0*sigIG*sigIG),sqrt(2.0*sigIB*sigIB),N,error);
  delete myFGT;
  
  
  
  savePPM(inR,inG,inB,argv[2]);
  delete inR;
  delete inG;
  delete inB;
  
  return 0;
}

