#include"ANN/ANN.h"
class ImageAnalogy{
 public:
  int Rch,Rc,Rl;
  double BlackY;
  ImageAnalogy(int dRc){
    Rch=Rc=dRc;
    if(Rc<=1){
      Rc=Rch=2;
    }
    Rl=Rc-1;
    
    BlackY = (0.299*255.0+0.587*255.0+0.114*255.0);
  }

  class CImage{
  public:
    int sx,sy;
    int **X;
    int **Y;
    CImage(int dsx,int dsy){
      sx = dsx;
      sy = dsy;
      X = new int* [sy];
      Y = new int* [sy];
    int i;
    for(i=0;i<sy;i++){
      X[i] = new int[sx];
      Y[i] = new int[sx];
    }
    }
  ~CImage(){
     int i;
    for(i=0;i<sy;i++){
      delete [] X[i];
      delete [] Y[i];
    }
    delete [] X;
    delete [] Y;
  }


};

double gauss(double dx, double dy, double dsig) {
   double dist = dx-dy;
   return exp(-(dist*dist)*dsig);
 }

void setGaussWeight(int totalsize,double *gaussweight){
 
  
  double sig1 = 0.5/(((double)(Rl*Rl)));
  double sig2 = 0.5/(((double)(Rc*Rc)));
  
  int pos=0;
  double dvalX,dvalY,wX,wY,dval,weight;
  int i,j;
  for(i=-Rl;i<=Rl;i++){
    dvalY = ((double)(i));
    wY = gauss(dvalY,0.0,sig1);
    for(j=-Rl;j<=Rl;j++){
      dvalX = ((double)(j));
      wX = gauss(dvalX,0.0,sig1);
      gaussweight[pos] = wX*wY;
      
      pos++;
    }
  }
  for(i=-Rc;i<=Rc;i++){
    dvalY = ((double)(i));
    wY = gauss(dvalY,0.0,sig2);
    for(j=-Rc;j<=Rc;j++){
      dvalX = ((double)(j));
      wX = gauss(dvalX,0.0,sig2);
      gaussweight[pos] = wX*wY;
      pos++;
    }
  }
  
  
  for(i=-Rl;i<=Rl;i++){
    dvalY = ((double)(i));
    wY = gauss(dvalY,0.0,sig1);
    for(j=-Rl;j<=Rl;j++){
      dvalX = ((double)(j));
      wX = gauss(dvalX,0.0,sig1);
      gaussweight[pos] = wX*wY;
      
      pos++;
    }
  }
  for(i=-Rc;i<=0;i++){
    dvalY = ((double)(i));
    wY = gauss(dvalY,0.0,sig2);
    if(i==0){
      for(j=-Rc;j<0;j++){
	dvalX = ((double)(j));
	wX = gauss(dvalX,0.0,sig2);
	gaussweight[pos] = wX*wY;
	pos++;
      }
    }else{
      for(j=-Rc;j<=Rc;j++){
	dvalX = ((double)(j));
	wX = gauss(dvalX,0.0,sig2);
	gaussweight[pos] = wX*wY;
	pos++;
      }
      
    }
  }
  
}

void setGaussWeight_S(int totalsize,double *gaussweight){
 
  
  double sig1 = 0.5/(((double)(Rl*Rl)));
  double sig2 = 0.5/(((double)(Rc*Rc)));
  
  int pos=0;
  double dvalX,dvalY,wX,wY,dval,weight;
  int i,j;
  for(i=-Rl;i<=Rl;i++){
    dvalY = ((double)(i));
    wY = gauss(dvalY,0.0,sig1);
    for(j=-Rl;j<=Rl;j++){
      dvalX = ((double)(j));
      wX = gauss(dvalX,0.0,sig1);
      gaussweight[pos] = wX*wY;
      
      pos++;
    }
  }
  for(i=-Rc;i<=Rc;i++){
    dvalY = ((double)(i));
    wY = gauss(dvalY,0.0,sig2);
    for(j=-Rc;j<=Rc;j++){
      dvalX = ((double)(j));
      wX = gauss(dvalX,0.0,sig2);
      gaussweight[pos] = wX*wY;
      pos++;
    }
  }
  
  

}


void normalize(double *fvec1,int size){
  int i;
  double sum=0.0;
  for(i=0;i<size;i++){
    sum += fvec1[i];
  }
  if(sum>0.0){
    for(i=0;i<size;i++){
      fvec1[i]/=sum;
    }
  }
  
}
void setFeatureVectorTotal(int j,int i,GaussianPyramid *B,GaussianPyramid *Bd,int level,double *fvec1,double *gaussweight,int fvecsize){
  int ii,jj,pos;
  pos=0;
  
  for(ii=-Rl;ii<=Rl;ii++){
    int ii2 = ii+i/2;
    
    for(jj=-Rl;jj<=Rl;jj++){
      int jj2 = jj+j/2;
    
      if(ii2<0||jj2<0||ii2>B->imgs[level+1]->sy-1||jj2>B->imgs[level+1]->sx-1){
      	fvec1[pos] = BlackY;
	
	
      }else{
	fvec1[pos] = B->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	
	
      }
      pos++;
    }
  }
  
  for(ii=-Rc;ii<=Rc;ii++){
    int ii2 = ii+i;
    
    for(jj=-Rc;jj<=Rc;jj++){
      int jj2 = jj+j;
      
      if(ii2<0||jj2<0||ii2>B->imgs[level]->sy-1||jj2>B->imgs[level]->sx-1){
	fvec1[pos] = BlackY;
	
      }else{
	fvec1[pos] = B->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	
	
      }
      pos++;
    }
  }
  for(ii=-Rl;ii<=Rl;ii++){
    int ii2 = ii+i/2;
    
    for(jj=-Rl;jj<=Rl;jj++){
      int jj2 = jj+j/2;
      
      if(ii2<0||jj2<0||ii2>Bd->imgs[level+1]->sy-1||jj2>Bd->imgs[level+1]->sx-1){
      	fvec1[pos] = BlackY;
	
      }else{
	fvec1[pos] = Bd->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	
	
      }
      pos++;
    }
  }
  
  
  for(ii=-Rc;ii<=0;ii++){
    int ii2 = ii+i;
    
    if(ii==0){
      for(jj=-Rc;jj<0;jj++){
	int jj2 = jj+j;
	
	if(ii2<0||jj2<0||ii2>Bd->imgs[level]->sy-1||jj2>Bd->imgs[level]->sx-1){
	  fvec1[pos] = BlackY;
	  
	  
	}else{
	  fvec1[pos] = Bd->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	  
	  
	}
	pos++;
      }
    }else{
      for(jj=-Rc;jj<=Rc;jj++){
	int jj2 = jj+j;
	
	if(ii2<0||jj2<0||ii2>Bd->imgs[level]->sy-1||jj2>Bd->imgs[level]->sx-1){
	   fvec1[pos] = BlackY;
	   
	   
	 }else{
	   fvec1[pos] = Bd->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	   
	   
	}
	pos++;
      }
    }
  }
  //normalize(fvec1,fvecsize);
}

void setFeatureVector(int j,int i,GaussianPyramid *B,GaussianPyramid *Bd,int level,double *fvec1,double *gaussweight,int fvecsize){
  int ii,jj,pos;
  pos=0;
  
  for(ii=-Rl;ii<=Rl;ii++){
    int ii2 = ii+i/2;
    
    for(jj=-Rl;jj<=Rl;jj++){
      int jj2 = jj+j/2;
    
      if(ii2<0||jj2<0||ii2>B->imgs[level+1]->sy-1||jj2>B->imgs[level+1]->sx-1){
      	fvec1[pos] = BlackY;
	
	
      }else{
	fvec1[pos] = B->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	
	
      }
      pos++;
    }
  }
  
  for(ii=-Rc;ii<=Rc;ii++){
    int ii2 = ii+i;
    
    for(jj=-Rc;jj<=Rc;jj++){
      int jj2 = jj+j;
      
      if(ii2<0||jj2<0||ii2>B->imgs[level]->sy-1||jj2>B->imgs[level]->sx-1){
	fvec1[pos] = BlackY;
	
      }else{
	fvec1[pos] = B->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	
	
      }
      pos++;
    }
  }
  
}



void setFeatureVectorTotal(int j,int i,ColorGaussianPyramid *B,ColorGaussianPyramid *Bd,int level,double *fvec1,double *gaussweight,int fvecsize){
  int ii,jj,pos;
  pos=0;
  
  for(ii=-Rl;ii<=Rl;ii++){
    int ii2 = ii+i/2;
    //if(ii2<0)ii2=0;if(ii2>B->imgs[level+1]->sy-1)ii2=B->imgs[level+1]->sy-1;
    for(jj=-Rl;jj<=Rl;jj++){
      int jj2 = jj+j/2;
      //if(jj2<0)jj2=0;if(jj2>B->imgs[level+1]->sx-1)jj2=B->imgs[level+1]->sx-1;
      if(ii2<0||jj2<0||ii2>B->R->imgs[level+1]->sy-1||jj2>B->R->imgs[level+1]->sx-1){
      	fvec1[3*pos] = BlackY;
	fvec1[3*pos+1] = BlackY;
	fvec1[3*pos+2] = BlackY;
	
      }else{
	fvec1[3*pos] = B->R->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	fvec1[3*pos+1] = B->G->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	fvec1[3*pos+2] = B->B->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	
      }
      pos++;
    }
  }
  
  for(ii=-Rc;ii<=Rc;ii++){
    int ii2 = ii+i;
    //if(ii2<0)ii2=0;if(ii2>B->R->imgs[level]->sy-1)ii2=B->R->imgs[level]->sy-1;
    for(jj=-Rc;jj<=Rc;jj++){
      int jj2 = jj+j;
      //if(jj2<0)jj2=0;if(jj2>B->R->imgs[level]->sx-1)jj2=B->R->imgs[level]->sx-1;
      if(ii2<0||jj2<0||ii2>B->R->imgs[level]->sy-1||jj2>B->R->imgs[level]->sx-1){
	fvec1[3*pos] = BlackY;
	fvec1[3*pos+1] = BlackY;
	fvec1[3*pos+2] = BlackY;
      }else{
	fvec1[3*pos] = B->R->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	fvec1[3*pos+1] = B->G->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	fvec1[3*pos+2] = B->B->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	
      }
      pos++;
    }
  }
  for(ii=-Rl;ii<=Rl;ii++){
    int ii2 = ii+i/2;
    //if(ii2<0)ii2=0;if(ii2>Bd->R->imgs[level+1]->sy-1)ii2=Bd->R->imgs[level+1]->sy-1;
    for(jj=-Rl;jj<=Rl;jj++){
      int jj2 = jj+j/2;
      //if(jj2<0)jj2=0;if(jj2>Bd->R->imgs[level+1]->sx-1)jj2=Bd->R->imgs[level+1]->sx-1;
      if(ii2<0||jj2<0||ii2>Bd->R->imgs[level+1]->sy-1||jj2>Bd->R->imgs[level+1]->sx-1){
      	fvec1[3*pos] = BlackY;
	fvec1[3*pos+1] = BlackY;
	fvec1[3*pos+2] = BlackY;
      }else{
	fvec1[3*pos] = Bd->R->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	fvec1[3*pos+1] = Bd->G->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	fvec1[3*pos+2] = Bd->B->imgs[level+1]->img[ii2][jj2]*gaussweight[pos];
	
      }
      pos++;
    }
  }
  
  
  for(ii=-Rc;ii<=0;ii++){
    int ii2 = ii+i;
    //if(ii2<0)ii2=0;if(ii2>Bd->R->imgs[level]->sy-1)ii2=Bd->R->imgs[level]->sy-1;
    if(ii==0){
      for(jj=-Rc;jj<0;jj++){
	int jj2 = jj+j;
	//if(jj2<0)jj2=0;if(jj2>Bd->R->imgs[level]->sx-1)jj2=Bd->R->imgs[level]->sx-1;
	if(ii2<0||jj2<0||ii2>Bd->R->imgs[level]->sy-1||jj2>Bd->R->imgs[level]->sx-1){
	  fvec1[3*pos] = BlackY;
	  fvec1[3*pos+1] = BlackY;
	  fvec1[3*pos+2] = BlackY;
	  
	}else{
	  fvec1[3*pos] = Bd->R->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	  fvec1[3*pos+1] = Bd->G->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	  fvec1[3*pos+2] = Bd->B->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	  
	}
	pos++;
      }
    }else{
      for(jj=-Rc;jj<=Rc;jj++){
	int jj2 = jj+j;
	//if(jj2<0)jj2=0;if(jj2>Bd->R->imgs[level]->sx-1)jj2=Bd->R->imgs[level]->sx-1;
	if(ii2<0||jj2<0||ii2>Bd->R->imgs[level]->sy-1||jj2>Bd->R->imgs[level]->sx-1){
	   fvec1[3*pos] = BlackY;
	   fvec1[3*pos+1] = BlackY;
	   fvec1[3*pos+2] = BlackY;
	   
	 }else{
	   fvec1[3*pos] = Bd->R->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	   fvec1[3*pos+1] = Bd->G->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	   fvec1[3*pos+2] = Bd->B->imgs[level]->img[ii2][jj2]*gaussweight[pos];
	   
	}
	pos++;
      }
    }
  }
  //normalize(fvec1,fvecsize);
}



double diff2(double * fvec1,double * fvec2,int size){
  int i;
  double sum=0.0;
  for(i=0;i<size;i++){
    double dif = fvec1[i]-fvec2[i];
    sum += dif*dif;
  }
  return (sum);
}




void BestMatchTotal(CImage *mycoord,ANNkd_tree *kdTreeA,ANNpointArray *dataPtsA,int Asx,ColorGaussianPyramid *Ad,ColorGaussianPyramid *B,ANNidxArray nnIdx,ANNdistArray dists,ColorGaussianPyramid *Bd,double k,int level,int maxlevel,int j,int i,int *px,int *py, int *px2,int *py2, ANNpoint queryPt,double *fvec1,double *fvec2,int size1,int size2,int totalsize,double *gaussweight,double error){
  
  int pappX,pappY,pcohX,pcohY;
  //BestApproximateMatch
  
  int ii,jj;
  setFeatureVectorTotal(j,i,B,Bd,level,fvec1,gaussweight,totalsize);
  for(ii=0;ii<totalsize;ii++)queryPt[ii] = fvec1[ii];
  
  kdTreeA->annkSearch(queryPt,1,nnIdx,dists,error);
  double dapp = dists[0];
  pappY = ((int)(nnIdx[0]/Asx));
  pappX = ((int)(nnIdx[0] % Asx));
  
  
  //BestCoherenceMatch
  bool firstcheck=true;
  double min;
  int minx,miny,tx,ty;
  
  for(ii=-Rch;ii<=0;ii++){
    int ii2 = ii+i;
    if(ii2<0)ii2=0;if(ii2>Bd->R->imgs[level]->sy-1)ii2=Bd->R->imgs[level]->sy-1;
    
    
    if(ii==0){
      for(jj=-Rch;jj<0;jj++){
	int jj2 = jj+j;
	if(jj2<0)jj2=0;if(jj2>Bd->R->imgs[level]->sx-1)jj2=Bd->R->imgs[level]->sx-1;
	if(mycoord->X[ii2][jj2]!=-1&&mycoord->Y[ii2][jj2]!=-1){
	  ty = mycoord->Y[ii2][jj2]-ii;
	  tx = mycoord->X[ii2][jj2]-jj;
	  /* }else{
	  ty = pappY;
	  tx = pappX;
	  }*/
	  //if(ty<0)ty=0;if(ty>Ad->imgs[level]->sy-1)ty=Ad->imgs[level]->sy-1;
	  //if(tx<0)tx=0;if(tx>Ad->imgs[level]->sx-1)tx=Ad->imgs[level]->sx-1;
	  if(tx<0||ty<0||tx>Ad->R->imgs[level]->sx-1||ty>Ad->R->imgs[level]->sy-1){
	  
	  }else{
	//setFeatureVectorTotal(tx,ty,A,Ad,level,fvec2,gaussweight,totalsize);
	  
	  for(int iii=0;iii<totalsize;iii++)
	    fvec2[iii] = (*dataPtsA)[(ty*Ad->R->imgs[level]->sx+tx)][iii];
	  
	  double val = diff2(fvec1,fvec2,totalsize);
	  if(firstcheck){
	    min=val;
	    minx = tx;
	    miny = ty;
	    firstcheck=false;
	  }else{
	    if(min>val){
	      min=val;
	      minx = tx;
	      miny = ty;
	    }
	  }
	  }
	}
      }
    }else{
      for(jj=-Rch;jj<=Rch;jj++){
	int jj2 = jj+j;
	if(jj2<0)jj2=0;if(jj2>Bd->R->imgs[level]->sx-1)jj2=Bd->R->imgs[level]->sx-1;
	if(mycoord->X[ii2][jj2]!=-1&&mycoord->Y[ii2][jj2]!=-1){
	  ty = mycoord->Y[ii2][jj2]-ii;
	  tx = mycoord->X[ii2][jj2]-jj;
	  
	  if(tx<0||ty<0||tx>Ad->R->imgs[level]->sx-1||ty>Ad->R->imgs[level]->sy-1){
	  
	  }else{
	  
	  for(int iii=0;iii<totalsize;iii++)
	    fvec2[iii] = (*dataPtsA)[(ty*Ad->R->imgs[level]->sx+tx)][iii];
	  double val = diff2(fvec1,fvec2,totalsize);
	  if(firstcheck){
	    min=val;
	    minx = tx;
	    miny = ty;
	    firstcheck=false;
	  }else{
	    if(min>val){
	      min=val;
	      minx = tx;
	      miny = ty;
	    }
	  }
	}	
	}
       }
    }
  }
  
  if(firstcheck){
    (*px) = pappX;
    (*py) = pappY;
    
  }else{
    double dcoh = min;
    pcohX=minx;
    pcohY=miny;
    if(dcoh<=dapp*(1.0+k*pow(2.0,(level)))){
      (*px) = pcohX;
      (*py) = pcohY;
    }else{
      (*px) = pappX;
      (*py) = pappY;
      
    }
  
  }
  (*px2) = pappX;
  (*py2) = pappY;
     /*
  
   if(firstcheck){
     (*px2) = pappX;
     (*py2) = pappY;
   }else{
     (*px2) = pcohX;
     (*py2) = pcohY;
   }
     */
  
}



void BestMatchTotal(CImage *mycoord,ANNkd_tree *kdTreeA,ANNpointArray *dataPtsA,int Asx,GaussianPyramid *Ad,GaussianPyramid *B,ANNidxArray nnIdx,ANNdistArray dists,GaussianPyramid *Bd,double k,int level,int maxlevel,int j,int i,int *px,int *py, ANNpoint queryPt,double *fvec1,double *fvec2,int size1,int size2,int totalsize,double *gaussweight,double error){
  
  int pappX,pappY,pcohX,pcohY;
  //BestApproximateMatch
  
  int ii,jj;
  setFeatureVectorTotal(j,i,B,Bd,level,fvec1,gaussweight,totalsize);
  for(ii=0;ii<totalsize;ii++)queryPt[ii] = fvec1[ii];
  
  kdTreeA->annkSearch(queryPt,1,nnIdx,dists,error);
  double dapp = dists[0];
  pappY = ((int)(nnIdx[0]/Asx));
  pappX = ((int)(nnIdx[0] % Asx));
  
  
  //BestCoherenceMatch
  bool firstcheck=true;
  double min;
  int minx,miny,tx,ty;
  
  for(ii=-Rch;ii<=0;ii++){
    int ii2 = ii+i;
    if(ii2<0)ii2=0;if(ii2>Bd->imgs[level]->sy-1)ii2=Bd->imgs[level]->sy-1;
    
    
    if(ii==0){
      for(jj=-Rch;jj<0;jj++){
	int jj2 = jj+j;
	if(jj2<0)jj2=0;if(jj2>Bd->imgs[level]->sx-1)jj2=Bd->imgs[level]->sx-1;
	if(mycoord->X[ii2][jj2]!=-1&&mycoord->Y[ii2][jj2]!=-1){
	  ty = mycoord->Y[ii2][jj2]-ii;
	  tx = mycoord->X[ii2][jj2]-jj;
	  /* }else{
	  ty = pappY;
	  tx = pappX;
	  }*/
	  //if(ty<0)ty=0;if(ty>Ad->imgs[level]->sy-1)ty=Ad->imgs[level]->sy-1;
	  //if(tx<0)tx=0;if(tx>Ad->imgs[level]->sx-1)tx=Ad->imgs[level]->sx-1;
	  if(tx<0||ty<0||tx>Ad->imgs[level]->sx-1||ty>Ad->imgs[level]->sy-1){
	  
	  }else{
	//setFeatureVectorTotal(tx,ty,A,Ad,level,fvec2,gaussweight,totalsize);
	  
	  for(int iii=0;iii<totalsize;iii++)
	    fvec2[iii] = (*dataPtsA)[(ty*Ad->imgs[level]->sx+tx)][iii];
	  
	  double val = diff2(fvec1,fvec2,totalsize);
	  if(firstcheck){
	    min=val;
	    minx = tx;
	    miny = ty;
	    firstcheck=false;
	  }else{
	    if(min>val){
	      min=val;
	      minx = tx;
	      miny = ty;
	    }
	  }
	  }
	}
      }
    }else{
      for(jj=-Rch;jj<=Rch;jj++){
	int jj2 = jj+j;
	if(jj2<0)jj2=0;if(jj2>Bd->imgs[level]->sx-1)jj2=Bd->imgs[level]->sx-1;
	if(mycoord->X[ii2][jj2]!=-1&&mycoord->Y[ii2][jj2]!=-1){
	  ty = mycoord->Y[ii2][jj2]-ii;
	  tx = mycoord->X[ii2][jj2]-jj;
	  /* }else{
	  ty = pappY;
	  tx = pappX;
	  }*/
	  //if(ty<0)ty=0;if(ty>Ad->imgs[level]->sy-1)ty=Ad->imgs[level]->sy-1;
	  //if(tx<0)tx=0;if(tx>Ad->imgs[level]->sx-1)tx=Ad->imgs[level]->sx-1;
	  if(tx<0||ty<0||tx>Ad->imgs[level]->sx-1||ty>Ad->imgs[level]->sy-1){
	  
	  }else{
	  //setFeatureVectorTotal(tx,ty,A,Ad,level,fvec2,gaussweight,totalsize);
	  for(int iii=0;iii<totalsize;iii++)
	    fvec2[iii] = (*dataPtsA)[(ty*Ad->imgs[level]->sx+tx)][iii];
	  double val = diff2(fvec1,fvec2,totalsize);
	  if(firstcheck){
	    min=val;
	    minx = tx;
	    miny = ty;
	    firstcheck=false;
	  }else{
	    if(min>val){
	      min=val;
	      minx = tx;
	      miny = ty;
	    }
	  }
	}	
	}
       }
    }
  }

   
  if(firstcheck){
    (*px) = pappX;
    (*py) = pappY;
    
  }else{
    double dcoh = min;
    pcohX=minx;
    pcohY=miny;
    if(dcoh<=dapp*(1.0+k*pow(2.0,(-level)))){
      (*px) = pcohX;
      (*py) = pcohY;
    }else{
      (*px) = pappX;
      (*py) = pappY;
      
    }
    //(*px) = pcohX;
    //(*py) = pcohY;
    }
  
  
  
  //(*px) = pappX;
  //(*py) = pappY;
  
}



 void BestMatchTotal_S(CImage *mycoord,ANNkd_tree *kdTreeA,ANNpointArray *dataPtsA,int Asx,GaussianPyramid *Ad,GaussianPyramid *B,ANNidxArray nnIdx,ANNdistArray dists,GaussianPyramid *Bd,double k,int level,int maxlevel,int j,int i,int *pappX,int *pappY, int *pcohX,int *pcohY,ANNpoint queryPt,double *fvec1,double *fvec2,int size1,int size2,int totalsize,double *gaussweight,double error){
  
  //BestApproximateMatch
  
  int ii,jj;
  setFeatureVector(j,i,B,Bd,level,fvec1,gaussweight,totalsize);
  for(ii=0;ii<totalsize;ii++)queryPt[ii] = fvec1[ii];
  
  kdTreeA->annkSearch(queryPt,1,nnIdx,dists,error);
  double dapp = dists[0];
  (*pappY) = ((int)(nnIdx[0]/Asx));
  (*pappX) = ((int)(nnIdx[0] % Asx));
  
  
  //BestCoherenceMatch
  bool firstcheck=true;
  double min;
  int minx,miny,tx,ty;
  
  for(ii=-Rch;ii<=0;ii++){
    int ii2 = ii+i;
    if(ii2<0)ii2=0;if(ii2>Bd->imgs[level]->sy-1)ii2=Bd->imgs[level]->sy-1;
    
    
    if(ii==0){
      for(jj=-Rch;jj<0;jj++){
	int jj2 = jj+j;
	if(jj2<0)jj2=0;if(jj2>Bd->imgs[level]->sx-1)jj2=Bd->imgs[level]->sx-1;
	if(mycoord->X[ii2][jj2]!=-1&&mycoord->Y[ii2][jj2]!=-1){
	  ty = mycoord->Y[ii2][jj2]-ii;
	  tx = mycoord->X[ii2][jj2]-jj;
	  if(tx<0||ty<0||tx>Ad->imgs[level]->sx-1||ty>Ad->imgs[level]->sy-1){
	  
	  }else{
		  
	  for(int iii=0;iii<totalsize;iii++)
	    fvec2[iii] = (*dataPtsA)[(ty*Ad->imgs[level]->sx+tx)][iii];
	  
	  double val = diff2(fvec1,fvec2,totalsize);
	  if(firstcheck){
	    min=val;
	    minx = tx;
	    miny = ty;
	    firstcheck=false;
	  }else{
	    if(min>val){
	      min=val;
	      minx = tx;
	      miny = ty;
	    }
	  }
	  }
	}
      }
    }else{
      for(jj=-Rch;jj<=Rch;jj++){
	int jj2 = jj+j;
	if(jj2<0)jj2=0;if(jj2>Bd->imgs[level]->sx-1)jj2=Bd->imgs[level]->sx-1;
	if(mycoord->X[ii2][jj2]!=-1&&mycoord->Y[ii2][jj2]!=-1){
	  ty = mycoord->Y[ii2][jj2]-ii;
	  tx = mycoord->X[ii2][jj2]-jj;
	 
	  if(tx<0||ty<0||tx>Ad->imgs[level]->sx-1||ty>Ad->imgs[level]->sy-1){
	  
	  }else{
	 
	  for(int iii=0;iii<totalsize;iii++)
	    fvec2[iii] = (*dataPtsA)[(ty*Ad->imgs[level]->sx+tx)][iii];
	  double val = diff2(fvec1,fvec2,totalsize);
	  if(firstcheck){
	    min=val;
	    minx = tx;
	    miny = ty;
	    firstcheck=false;
	  }else{
	    if(min>val){
	      min=val;
	      minx = tx;
	      miny = ty;
	    }
	  }
	}	
	}
       }
    }
  }

   
  if(firstcheck){
    (*pcohX) = -1;
    (*pcohY) = -1;
    
  }else{
    (*pcohX) = minx;
    (*pcohY) = miny;
  
  }
  
}





void remapping(ColorImage *iA,ColorImage *iB){
  
  double uA=0.0;
  double uB=0.0;
  double sA=0.0;
  double sB=0.0;
  int i,j;
  for(i=0;i<iA->sy;i++)
    for(j=0;j<iA->sx;j++){
      uA+=iA->R->img[i][j];
      sA+=iA->R->img[i][j]*iA->R->img[i][j];
    }
  uA /= ((double)(iA->sx*iA->sy));
  sA /= ((double)(iA->sx*iA->sy));
  sA-=uA*uA;
  uA=sqrt(uA);
  for(i=0;i<iB->sy;i++)
    for(j=0;j<iB->sx;j++){
      uB+=iB->R->img[i][j];
      sB+=iB->R->img[i][j]*iB->R->img[i][j];
    }
  uB /= ((double)(iB->sx*iB->sy));
  sB /= ((double)(iB->sx*iB->sy));
  sB-=uB*uB;
  uB=sqrt(uB);
  for(i=0;i<iA->sy;i++)
    for(j=0;j<iA->sx;j++){
      iA->R->img[i][j] = (uB/uA)*(iA->R->img[i][j]-uA)+uB;
      
    }

}


void doTextureByNumbers(ColorImage *iA,ColorImage *iAd,ColorImage *iB,ColorImage *iBd,double k,double error){
  
  /*  iA->RGB2YIQ();
  iAd->RGB2YIQ();
  iB->RGB2YIQ();
  */
  ColorGaussianPyramid *A = new ColorGaussianPyramid(iA);
  ColorGaussianPyramid *Ad = new ColorGaussianPyramid(iAd);
  ColorGaussianPyramid *B = new ColorGaussianPyramid(iB);
  ColorGaussianPyramid *Bd = new ColorGaussianPyramid(iBd);
  int l,i,j;
  int level = A->level;
  if(B->level<level)level=B->level;
  
  int size1 = ((2*Rc+1)*(2*Rc+1)+(2*Rl+1)*(2*Rl+1));
  int size2 = ((((2*Rc+1)*(2*Rc+1)-1)/2)+1+(2*Rl+1)*(2*Rl+1))-1;
  
  int totalsize=3*(size1+size2);
  
  double *fvec1 = new double[totalsize];
  double *fvec2 = new double[totalsize];
  ANNpoint queryPt= new ANNcoord[totalsize];
  double *gaussweight = new double[(size1+size2)];
  setGaussWeight((size1+size2),gaussweight);
  
  
  
  printf("End pre-processing: Gaussian Pyramid level %d\n",level);
  ANNidxArray nnIdx = new ANNidx[1];
  ANNdistArray dists = new ANNdist[1];
  
  for(i=0;i<Bd->R->imgs[level-1]->sy;i++){
    for(j=0;j<Bd->R->imgs[level-1]->sx;j++){
      Bd->R->imgs[level-1]->img[i][j] = B->R->imgs[level-1]->img[i][j];
      Bd->G->imgs[level-1]->img[i][j] = B->G->imgs[level-1]->img[i][j];
      Bd->B->imgs[level-1]->img[i][j] = B->B->imgs[level-1]->img[i][j];
      
    }
  }
  
  
  for(l=level-2;l>=0;l--){
    printf("processing level = %d\n",l);
    ANNpointArray  dataPtsA;
    int nPtsA;
    
    
    
    
    nPtsA = A->R->imgs[l]->sx*A->R->imgs[l]->sy;
    dataPtsA = annAllocPts(nPtsA,totalsize);
    
    for(i=0;i<A->R->imgs[l]->sy;i++){
      for(j=0;j<A->R->imgs[l]->sx;j++){
	setFeatureVectorTotal(j,i,A,Ad,l,fvec1,gaussweight,totalsize);
	for(int pos=0;pos<totalsize;pos++)
	  dataPtsA[(i*A->R->imgs[l]->sx+j)][pos] = fvec1[pos];
      }
    }
    
    
    ANNkd_tree *kdTreeA = new ANNkd_tree(dataPtsA,nPtsA,totalsize);
    
    CImage *mycoord = new CImage(Bd->R->imgs[l]->sx,Bd->R->imgs[l]->sy);
    
    for(i=0;i<Bd->R->imgs[l]->sy;i++){
      for(j=0;j<Bd->R->imgs[l]->sx;j++){
	mycoord->X[i][j] = -1;
	mycoord->Y[i][j] = -1;
      }
    }
    
    
    
    for(i=0;i<Bd->R->imgs[l]->sy;i++){
      int py=i; int py2=i;
      for(j=0;j<Bd->R->imgs[l]->sx;j++){
	int px=j;int px2=j;
	
	BestMatchTotal(mycoord,kdTreeA,&dataPtsA,A->R->imgs[l]->sx,Ad,B,nnIdx,dists,Bd,k,l,level,j,i,&px,&py,&px2,&py2,queryPt,fvec1,fvec2,size1,size2,totalsize,gaussweight,error);
	
	
	if(px<0)px=0;if(px>A->sx-1)px=A->sx-1;
	if(py<0)py=0;if(py>A->sy-1)py=A->sy-1;
	mycoord->X[i][j] = px;
	mycoord->Y[i][j] = py;
	
	
	Bd->R->imgs[l]->img[i][j] = Ad->R->imgs[l]->img[py][px];
	Bd->G->imgs[l]->img[i][j] = Ad->G->imgs[l]->img[py][px];
	Bd->B->imgs[l]->img[i][j] = Ad->B->imgs[l]->img[py][px];
	/*
	if(l==0){
	  iBd->G->img[i][j] = iAd->G->img[py][px];
	  iBd->B->img[i][j] = iAd->B->img[py][px];
	  
	}
	*/
	
      }
    }

    delete kdTreeA;
    
    
    annDeallocPts(dataPtsA);
    
    annClose();
    delete mycoord;
  }
  
  delete [] nnIdx;
  delete [] dists;

  for(i=0;i<iBd->sy;i++){
    for(j=0;j<iBd->sx;j++){
      iBd->R->img[i][j] = Bd->R->imgs[0]->img[i][j];
      iBd->G->img[i][j] = Bd->G->imgs[0]->img[i][j];
      iBd->B->img[i][j] = Bd->B->imgs[0]->img[i][j];
      
      
      //iBd->G->img[i][j] = iB->G->img[i][j];
      //iBd->B->img[i][j] = iB->B->img[i][j];
      
    }
  } 
  //iBd->YIQ2RGB();
  delete [] fvec1;
  delete [] fvec2;
  delete [] queryPt;
  
  delete [] gaussweight; 
  delete A;
  delete Ad;
  delete B;
  delete Bd;

}

void doArtisticFilter(ColorImage *iA,ColorImage *iAd,ColorImage *iB,ColorImage *iBd,double k,double error){
  
  iA->RGB2YIQ();
  iAd->RGB2YIQ();
  iB->RGB2YIQ();
  //remapping(iA,iB);
  
  GaussianPyramid *A = new GaussianPyramid(iA->R);
  GaussianPyramid *Ad = new GaussianPyramid(iAd->R);
  GaussianPyramid *B = new GaussianPyramid(iB->R);
  GaussianPyramid *Bd = new GaussianPyramid(iBd->R);
  int l,i,j;
  int level = A->level;
  if(B->level<level)level=B->level;
  
  int size1 = ((2*Rc+1)*(2*Rc+1)+(2*Rl+1)*(2*Rl+1));
  int size2 = ((((2*Rc+1)*(2*Rc+1)-1)/2)+1+(2*Rl+1)*(2*Rl+1))-1;
  
  int totalsize=(size1+size2);
  
  double *fvec1 = new double[totalsize];
  double *fvec2 = new double[totalsize];
  ANNpoint queryPt= new ANNcoord[totalsize];
  double *gaussweight = new double[(size1+size2)];
  setGaussWeight((size1+size2),gaussweight);
  
  
  
  printf("End pre-processing: Gaussian Pyramid level %d\n",level);
  ANNidxArray nnIdx = new ANNidx[1];
  ANNdistArray dists = new ANNdist[1];
  
  for(i=0;i<Bd->imgs[level-1]->sy;i++){
    for(j=0;j<Bd->imgs[level-1]->sx;j++){
      Bd->imgs[level-1]->img[i][j] = B->imgs[level-1]->img[i][j];
      
      
    }
  }
  
  
  for(l=level-2;l>=0;l--){
    printf("processing level = %d\n",l);
    ANNpointArray  dataPtsA;
    int nPtsA;
    
    
    
    
    nPtsA = A->imgs[l]->sx*A->imgs[l]->sy;
    dataPtsA = annAllocPts(nPtsA,totalsize);
    
    for(i=0;i<A->imgs[l]->sy;i++){
      for(j=0;j<A->imgs[l]->sx;j++){
	setFeatureVectorTotal(j,i,A,Ad,l,fvec1,gaussweight,totalsize);
	for(int pos=0;pos<totalsize;pos++)
	  dataPtsA[(i*A->imgs[l]->sx+j)][pos] = fvec1[pos];
      }
    }
    
    
    ANNkd_tree *kdTreeA = new ANNkd_tree(dataPtsA,nPtsA,totalsize);
    
    CImage *mycoord = new CImage(Bd->imgs[l]->sx,Bd->imgs[l]->sy);
    
    for(i=0;i<Bd->imgs[l]->sy;i++){
      for(j=0;j<Bd->imgs[l]->sx;j++){
	mycoord->X[i][j] = -1;
	mycoord->Y[i][j] = -1;
      }
    }
    
    
    
    for(i=0;i<Bd->imgs[l]->sy;i++){
      int py=i;
      for(j=0;j<Bd->imgs[l]->sx;j++){
	int px=j;
	
	BestMatchTotal(mycoord,kdTreeA,&dataPtsA,A->imgs[l]->sx,Ad,B,nnIdx,dists,Bd,k,l,level,j,i,&px,&py,queryPt,fvec1,fvec2,size1,size2,totalsize,gaussweight,error);
	
	
	if(px<0)px=0;if(px>A->sx-1)px=A->sx-1;
	if(py<0)py=0;if(py>A->sy-1)py=A->sy-1;
	mycoord->X[i][j] = px;
	mycoord->Y[i][j] = py;
	
	
	Bd->imgs[l]->img[i][j] = Ad->imgs[l]->img[py][px];
	

	
      }
    }

    delete kdTreeA;
    
    
    annDeallocPts(dataPtsA);
    
    annClose();
    delete mycoord;
  }
  
  delete [] nnIdx;
  delete [] dists;

  for(i=0;i<iBd->sy;i++){
    for(j=0;j<iBd->sx;j++){
      iBd->R->img[i][j] = Bd->imgs[0]->img[i][j];
      //iBd->G->img[i][j] = Bd->G->imgs[0]->img[i][j];
      //iBd->B->img[i][j] = Bd->B->imgs[0]->img[i][j];
      
      
      iBd->G->img[i][j] = iB->G->img[i][j];
      iBd->B->img[i][j] = iB->B->img[i][j];
      
    }
  } 
  iBd->YIQ2RGB();
  delete [] fvec1;
  delete [] fvec2;
  delete [] queryPt;
  
  delete [] gaussweight; 
  delete A;
  delete Ad;
  delete B;
  delete Bd;

}



void doColorFilter(ColorImage *iA,ColorImage *iAd,ColorImage *iB,ColorImage *iBd,double k,double error){
  
  iA->RGB2YIQ();
  iAd->RGB2YIQ();
  iB->RGB2YIQ();
  //remapping(iA,iB);
  
  GaussianPyramid *A = new GaussianPyramid(iA->R);
  GaussianPyramid *Ad = new GaussianPyramid(iAd->R);
  GaussianPyramid *B = new GaussianPyramid(iB->R);
  GaussianPyramid *Bd = new GaussianPyramid(iBd->R);
  int l,i,j;
  int level = A->level;
  if(B->level<level)level=B->level;
  
  int size1 = ((2*Rc+1)*(2*Rc+1)+(2*Rl+1)*(2*Rl+1));
  int size2 = 0;//((((2*Rc+1)*(2*Rc+1)-1)/2)+1+(2*Rl+1)*(2*Rl+1))-1;
  
  int totalsize=(size1+size2);
  
  double *fvec1 = new double[totalsize];
  double *fvec2 = new double[totalsize];
  ANNpoint queryPt= new ANNcoord[totalsize];
  double *gaussweight = new double[(size1)];
  setGaussWeight_S((size1),gaussweight);
  
  
  
  printf("End pre-processing: Gaussian Pyramid level %d\n",level);
  ANNidxArray nnIdx = new ANNidx[1];
  ANNdistArray dists = new ANNdist[1];
  
  for(i=0;i<Bd->imgs[level-1]->sy;i++){
    for(j=0;j<Bd->imgs[level-1]->sx;j++){
      Bd->imgs[level-1]->img[i][j] = B->imgs[level-1]->img[i][j];
    }
  }
  
  
  for(l=level-2;l>=0;l--){
    printf("processing level = %d\n",l);
    ANNpointArray  dataPtsA;
    int nPtsA;
    
    
    
    
    nPtsA = A->imgs[l]->sx*A->imgs[l]->sy;
    dataPtsA = annAllocPts(nPtsA,totalsize);
    
    for(i=0;i<A->imgs[l]->sy;i++){
      for(j=0;j<A->imgs[l]->sx;j++){
	setFeatureVector(j,i,A,Ad,l,fvec1,gaussweight,totalsize);
	for(int pos=0;pos<totalsize;pos++)
	  dataPtsA[(i*A->imgs[l]->sx+j)][pos] = fvec1[pos];
      }
    }
    
    
    ANNkd_tree *kdTreeA = new ANNkd_tree(dataPtsA,nPtsA,totalsize);
    
    CImage *mycoord = new CImage(Bd->imgs[l]->sx,Bd->imgs[l]->sy);
    
    for(i=0;i<Bd->imgs[l]->sy;i++){
      for(j=0;j<Bd->imgs[l]->sx;j++){
	mycoord->X[i][j] = -1;
	mycoord->Y[i][j] = -1;
      }
    }
    
    
    
    for(i=0;i<Bd->imgs[l]->sy;i++){
      
      for(j=0;j<Bd->imgs[l]->sx;j++){
	int px=j;
	int l2x,l2y;
	int tbx,tby;
	BestMatchTotal_S(mycoord,kdTreeA,&dataPtsA,A->imgs[l]->sx,Ad,B,nnIdx,dists,Bd,k,l,level,j,i,&l2x,&l2y,&tbx,&tby,queryPt,fvec1,fvec2,size1,size2,totalsize,gaussweight,error);
	
	
	if(l2x<0)l2x=0;if(l2x>A->sx-1)l2x=A->sx-1;
	if(l2y<0)l2y=0;if(l2y>A->sy-1)l2y=A->sy-1;

	Bd->imgs[l]->img[i][j] = Ad->imgs[l]->img[l2y][l2x];
	if(l==0){
	   iBd->G->img[i][j] = iAd->G->img[l2y][l2x];
	   iBd->B->img[i][j] = iAd->B->img[l2y][l2x];
	}
	
      }
    }

    delete kdTreeA;
    
    
    annDeallocPts(dataPtsA);
    
    annClose();
    delete mycoord;
  }
  
  delete [] nnIdx;
  delete [] dists;

  for(i=0;i<iBd->sy;i++){
    for(j=0;j<iBd->sx;j++){
      iBd->R->img[i][j] = Bd->imgs[0]->img[i][j];
      
      //iBd->G->img[i][j] = iB->G->img[i][j];
      //iBd->B->img[i][j] = iB->B->img[i][j];
      
    }
  } 
  iBd->YIQ2RGB();
  delete [] fvec1;
  delete [] fvec2;
  delete [] queryPt;
  
  delete [] gaussweight; 
  delete A;
  delete Ad;
  delete B;
  delete Bd;

}

 void doTextureTransfer(ColorImage *iA,ColorImage *iAd,ColorImage *iB,ColorImage *iBd,double k,double error,double alpha){
  
  
  ColorGaussianPyramid *A = new ColorGaussianPyramid(iA);
  ColorGaussianPyramid *Ad = new ColorGaussianPyramid(iAd);
  ColorGaussianPyramid *B = new ColorGaussianPyramid(iB);
  ColorGaussianPyramid *Bd = new ColorGaussianPyramid(iBd);
  int l,i,j;
  int level = A->level;
  if(B->level<level)level=B->level;
  
  int size1 = ((2*Rc+1)*(2*Rc+1)+(2*Rl+1)*(2*Rl+1));
  int size2 = ((((2*Rc+1)*(2*Rc+1)-1)/2)+1+(2*Rl+1)*(2*Rl+1))-1;
  
  int totalsize=3*(size1+size2);
  
  double *fvec1 = new double[totalsize];
  double *fvec2 = new double[totalsize];
  ANNpoint queryPt= new ANNcoord[totalsize];
  double *gaussweight = new double[(size1+size2)];
  setGaussWeight((size1+size2),gaussweight);
  
  
  
  printf("End pre-processing: Gaussian Pyramid level %d\n",level);
  ANNidxArray nnIdx = new ANNidx[1];
  ANNdistArray dists = new ANNdist[1];
  
  for(i=0;i<Bd->R->imgs[level-1]->sy;i++){
    for(j=0;j<Bd->R->imgs[level-1]->sx;j++){
      Bd->R->imgs[level-1]->img[i][j] = B->R->imgs[level-1]->img[i][j];
      Bd->G->imgs[level-1]->img[i][j] = B->G->imgs[level-1]->img[i][j];
      Bd->B->imgs[level-1]->img[i][j] = B->B->imgs[level-1]->img[i][j];
      
    }
  }
  
  
  for(l=level-2;l>=0;l--){
    printf("processing level = %d\n",l);
    ANNpointArray  dataPtsA;
    int nPtsA;
    
    
    
    
    nPtsA = A->R->imgs[l]->sx*A->R->imgs[l]->sy;
    dataPtsA = annAllocPts(nPtsA,totalsize);
    
    for(i=0;i<A->R->imgs[l]->sy;i++){
      for(j=0;j<A->R->imgs[l]->sx;j++){
	setFeatureVectorTotal(j,i,A,Ad,l,fvec1,gaussweight,totalsize);
	for(int pos=0;pos<totalsize;pos++)
	  dataPtsA[(i*A->R->imgs[l]->sx+j)][pos] = fvec1[pos];
      }
    }
    
    
    ANNkd_tree *kdTreeA = new ANNkd_tree(dataPtsA,nPtsA,totalsize);
    
    CImage *mycoord = new CImage(Bd->R->imgs[l]->sx,Bd->R->imgs[l]->sy);
    
    for(i=0;i<Bd->R->imgs[l]->sy;i++){
      for(j=0;j<Bd->R->imgs[l]->sx;j++){
	mycoord->X[i][j] = -1;
	mycoord->Y[i][j] = -1;
      }
    }
    
    
    
    for(i=0;i<Bd->R->imgs[l]->sy;i++){
      int py=i;
      int py2=i;
      for(j=0;j<Bd->R->imgs[l]->sx;j++){
	int px=j;
	int px2=j;
	BestMatchTotal(mycoord,kdTreeA,&dataPtsA,A->R->imgs[l]->sx,Ad,B,nnIdx,dists,Bd,k,l,level,j,i,&px,&py,&px2,&py2,queryPt,fvec1,fvec2,size1,size2,totalsize,gaussweight,error);
	
	
	if(px<0)px=0;if(px>A->sx-1)px=A->sx-1;
	if(py<0)py=0;if(py>A->sy-1)py=A->sy-1;
	if(px2<0)px2=0;if(px2>A->sx-1)px2=A->sx-1;
	if(py2<0)py2=0;if(py2>A->sy-1)py2=A->sy-1;
	
	mycoord->X[i][j] = px;
	mycoord->Y[i][j] = py;
	
       
	Bd->R->imgs[l]->img[i][j] = alpha*(Ad->R->imgs[l]->img[py][px])+(1.0-alpha)*Ad->R->imgs[l]->img[py2][px2];
	Bd->G->imgs[l]->img[i][j] = alpha*(Ad->G->imgs[l]->img[py][px])+(1.0-alpha)*Ad->G->imgs[l]->img[py2][px2];
	Bd->B->imgs[l]->img[i][j] = alpha*(Ad->B->imgs[l]->img[py][px])+(1.0-alpha)*Ad->B->imgs[l]->img[py2][px2];
	/*
	if(l==0){
	  iBd->G->img[i][j] = iAd->G->img[py][px];
	  iBd->B->img[i][j] = iAd->B->img[py][px];
	  
	}
	*/
	
      }
    }

    delete kdTreeA;
    
    
    annDeallocPts(dataPtsA);
    
    annClose();
    delete mycoord;
  }
  
  delete [] nnIdx;
  delete [] dists;

  for(i=0;i<iBd->sy;i++){
    for(j=0;j<iBd->sx;j++){
      iBd->R->img[i][j] = Bd->R->imgs[0]->img[i][j];
      iBd->G->img[i][j] = Bd->G->imgs[0]->img[i][j];
      iBd->B->img[i][j] = Bd->B->imgs[0]->img[i][j];
      
      
      //iBd->G->img[i][j] = iB->G->img[i][j];
      //iBd->B->img[i][j] = iB->B->img[i][j];
      
    }
  } 
  //iBd->YIQ2RGB();
  delete [] fvec1;
  delete [] fvec2;
  delete [] queryPt;
  
  delete [] gaussweight; 
  delete A;
  delete Ad;
  delete B;
  delete Bd;

}


};
